program hash;
uses crt;
type link_type=^element_type;
     element_type=record value:string;
                         link:link_type;
                         number:integer;
                         end;
procedure menu;
  begin
    writeln('1-dobavit v hash');
    writeln('2-udalit iz hasha');
    writeln('3-naiti v hashe');
    writeln('4-Bb|XOg');
  end;
function hash_code(new_value:string; max_count,power:integer):integer;
var i,code:integer;
    s:string[1];
    c:char;
  begin
    code:=0;
    for i:=1 to length(new_value) do
      begin
        s:=copy(new_value,i,1);
        c:=s[1];
        code:=code+ord(c);
      end;
    hash_code:=((code+power) mod max_count)+1;
  end;
function check_free_place(root:pointer; new_number:integer; var element:link_type):boolean;
var i:integer;
  begin
    element:=root;
    if (new_number>1)
    then
      begin
        for i:=2 to new_number do
          begin
            element:=element^.link;
          end;
      end;
    if (element^.value='')
    then
      begin
        check_free_place:=TRUE;
      end
    else
      begin
        check_free_place:=FALSE;
      end;
  end;
procedure add(var root:pointer; user:boolean; new_value:string; max_count:integer; var current_count:integer; var f:text);
var new_number,i,power:integer;
    element:link_type;
    error,free_place:boolean;
  begin
    error:=FALSE;
    new_number:=hash_code(new_value,max_count,0);
    element:=root;
    if (new_number>1)
    then
      begin
        for i:=2 to new_number do
          begin
            element:=element^.link;
          end;
      end;
    if (element^.value='')
    then
      begin
        element^.value:=new_value;
        current_count:=current_count+1;
      end
    else
      begin
        if (current_count<max_count)
        then
          begin
            free_place:=FALSE;
            power:=0;
            repeat
              power:=power+1;
              new_number:=hash_code(new_value,max_count,power);
              free_place:=check_free_place(root,new_number,element);
            until free_place;
            element^.value:=new_value;
            current_count:=current_count+1;
          end
        else
          begin
            error:=TRUE;
            if (user)
            then
              begin
                writeln('hash perpolnen.');
                readln;
              end
            else
              begin
                writeln(f,'error');
              end;
          end;
      end;
    if (not error)
    then
      begin
        if (not user)
        then
          begin
            writeln(f,'ok');
          end;
      end;
  end;
function check_value(root:pointer; number:integer; value:string; var element:link_type):boolean;
var finded:boolean;
    i:integer;
  begin
    element:=root;
    finded:=FALSE;
    if (number>1)
    then
      begin
        for i:=2 to number do
          begin
            element:=element^.link;
          end;
        if (element^.value=value)
        then
          begin
            finded:=TRUE;
          end;
      end
    else
      begin
        if (element^.value=value)
        then
          begin
            finded:=TRUE;
          end;
      end;
    check_value:=finded;
  end;
function find(value:string;var element:link_type; var root:pointer; max_count:integer):boolean;
var number,i,power:integer;
    finded:boolean;
  begin
    element:=root;
    finded:=FALSE;
    number:=hash_code(value,max_count,0);
    if (number>1)
    then
      begin
        for i:=2 to number do
          begin
            element:=element^.link;
          end;
        if (element^.value=value)
        then
          begin
            finded:=TRUE;
          end;
      end
    else
      begin
        if (element^.value=value)
        then
          begin
            finded:=TRUE;
          end;
      end;
    if (not finded)
    then
      begin
        power:=0;
        repeat
          power:=power+1;
          number:=hash_code(value,max_count,power);
          finded:=check_value(root,number,value,element);
        until ((finded)or(power>max_count));
      end;
    find:=finded;
  end;
procedure delete_element(value:string; var root:pointer; user:boolean; max_count:integer;
var current_count:integer; var f:text);
var finded:boolean;
    element:link_type;
  begin
    finded:=find(value,element,root,max_count);
    if (finded)
    then
      begin
        element^.value:='';
        current_count:=current_count-1;
        if (user)
        then
          begin
            writeln('element udalen');
            readln;
          end
        else
          begin
            writeln(f,'ok');
          end;
      end
    else
      begin
        if (user)
        then
          begin
            writeln('element ne naiden');
            readln;
          end
        else
          begin
            writeln(f,'error');
          end;
      end;
  end;
procedure search_element(var root:pointer; user:boolean; value:string; max_count:integer; var f:text);
var element:link_type;
    finded:boolean;
  begin
    finded:=find(value,element,root,max_count);
    if (finded)
    then
      begin
        if (user)
        then
          begin
            writeln('naiden');
            readln;
          end
        else
          begin
            writeln(f,'ok');
          end;
      end
    else
      begin
        if (user)
        then
          begin
            writeln('ne naiden');
            readln;
          end
        else
          begin
            writeln(f,'error');
          end;
      end;
  end;
procedure create_list(max_count:integer; var root:pointer);
var element:link_type;
    i:integer;
  begin
    new(element);
    root:=element;
    element^.value:='';
    element^.number:=1;
    element^.link:=nil;
    if (max_count>1)
    then
      begin
        for i:=2 to max_count do
          begin
            new(element^.link);
            element:=element^.link;
            element^.value:='';
            element^.number:=i;
            element^.link:=nil;
          end;
      end;
    element^.link:=root;
  end;
procedure user_interface(root:pointer);
var action_code,max_count,current_count:integer;
    value,new_value:string;
    user:boolean;
    var f:text;
  begin
     clrscr;
     current_count:=0;
     user:=TRUE;
     writeln('Makc. kolichestvo zapisey=');
     readln(max_count);
     create_list(max_count,root);
    repeat
      clrscr;
      menu;
      writeln('action code:');
      readln(action_code);
      case action_code of
      1:begin
          write('value=');
          readln(new_value);
          add(root,user,new_value,max_count,current_count,f);
        end;
      2:begin
          write('element=');
          readln(value);
          delete_element(value,root,user,max_count,current_count,f);
        end;
      3:begin
          write('element=');
          readln(value);
          search_element(root,user,value,max_count,f);
        end;
      end;
    until (action_code=4);
  end;
procedure file_interface(root:pointer; read_file,write_file:string);
var user:boolean;
    p,max_count,current_count,k:integer;
    f,f2:text;
    s,action,parametr_string:string;
  begin
    current_count:=0;
    user:=FALSE;
    assign(f2,read_file);
    reset(f2);
    assign(f,write_file);
    rewrite(f);
    readln(f2,s);
    p:=pos(' ',s);
    action:=copy(s,1,p-1);
    if (p=0)
    then
      begin
        action:=s;
      end;
    parametr_string:=copy(s,p+1,length(s)-p);
    val(parametr_string,max_count,k);
    create_list(max_count,root);
    while (not eof(f2)) do
      begin
        readln(f2,s);
        p:=pos(' ',s);
        action:=copy(s,1,p-1);
        if (p=0)
        then
          begin
            action:=s;
          end;
        parametr_string:=copy(s,p+1,length(s)-p);
        if (action='add')
        then
          begin
            add(root,user,parametr_string,max_count,current_count,f);
          end;
        if (action='delete')
        then
          begin
            delete_element(parametr_string,root,user,max_count,current_count,f);
          end;
        if (action='find')
        then
          begin
            search_element(root,user,parametr_string,max_count,f);
          end;
      end;
    close(f2);
    close(f);
  end;
var read_file,write_file:string;
    root:pointer;
begin
  root:=nil;
  if (paramstr(1)<>''){᫨  ࠬ  ப}
  then{}
    begin
      read_file:=paramstr(1);{뢠 䠩 -  ࠬ}
      write_file:=paramstr(2);{室 䠩 - ன ࠬ}
      file_interface(root,read_file,write_file);
    end
  else{᫨ , }
    begin
      user_interface(root);
    end;
end.
